(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var closest = function closest(el, root, attr) {
  var parent = el.parentNode;
  if (parent.dataset.focusHighlight !== 'wrapper' && parent !== document.body) {
    return closest(parent, root, attr);
  } else if (parent === document.body) {
    return root;
  } else {
    return parent;
  }
};

var throttle = function throttle(callback, limit) {
  var wait = false;
  return function () {
    if (!wait) {
      callback.call();
      wait = true;
      setTimeout(function () {
        wait = false;
      }, limit);
    }
  };
};

exports.default = {
  settings: {
    padding: 2,
    borderRadius: 4,
    borderThickness: 2,
    boxShadow: '0 0 5px 1px dodgerBlue',
    transitionDuration: 0.3,
    transitionTimingFunction: 'ease-in-out',
    color: 'dodgerBlue',
    customStyle: false,
    zIndex: 9999
  },
  focus: {},
  mouseDown: false,
  visible: false,
  init: function init(settings) {
    this.settings = Object.assign(this.settings, settings);
    this.focus = this.createFocus();
    this.addListeners();
  },
  createFocus: function createFocus() {
    var focus = document.createElement('div');

    document.body.appendChild(focus);
    focus.classList.add('focus');
    focus.style.position = 'absolute';
    focus.style.opacity = 0;
    focus.style.pointerEvents = 'none';

    if (!this.settings.customStyle) {
      this.appendDefaultStyle();
    }

    return focus;
  },
  appendDefaultStyle: function appendDefaultStyle() {
    var css = '\n      .focus {\n        border-radius: ' + this.settings.borderRadius + 'px;\n        border: ' + this.settings.borderThickness + 'px solid ' + this.settings.color + ';\n        box-shadow: ' + this.settings.boxShadow + ';\n        box-sizing: border-box;\n        top: 0;\n        left: 0;\n        transition-timing-function: ' + this.settings.transitionTimingFunction + ';\n        transition: width ' + this.settings.transitionDuration + 's, \n                    height ' + this.settings.transitionDuration + 's, \n                    left ' + this.settings.transitionDuration + 's, \n                    top ' + this.settings.transitionDuration + 's, \n                    opacity ' + this.settings.transitionDuration + 's, \n                    border-radius .2s;\n        z-index: ' + this.settings.zIndex + ';            \n      }\n    ';
    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');

    style.type = 'text/css';

    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }

    head.appendChild(style);
  },
  addListeners: function addListeners() {
    var _this = this;

    document.documentElement.addEventListener('mousedown', function (e) {
      _this.mouseDown = true;
      _this.hide();
    });
    document.documentElement.addEventListener('mouseup', function (e) {
      _this.mouseDown = false;
    });
    document.documentElement.addEventListener('customFocus', function (e) {
      _this.move(e);
    });
    document.documentElement.addEventListener('focus', function (e) {
      if (!_this.mouseDown && e.target !== document.body) {
        _this.move(e);
      }
    }, true);
    document.addEventListener('blur', function (e) {
      _this.hide();
    }, true);
    window.addEventListener('resize', throttle(this.hide.bind(this), 500));
  },
  move: function move(e) {
    var target = closest(e.target, e.target, 'wrapper');
    var rect = target.getBoundingClientRect();
    var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;

    if (target.type === 'radio') {
      this.focus.style.borderRadius = '50%';
    } else {
      this.focus.style.borderRadius = this.settings.borderRadius + 'px';
    }

    target.style.outline = 'none';
    this.focus.style.width = rect.width + this.settings.padding + 'px';
    this.focus.style.height = rect.height + this.settings.padding + 'px';
    this.focus.style.left = rect.left - this.settings.padding / 2 + 'px';
    this.focus.style.top = rect.top + scrollTop - this.settings.padding / 2 + 'px';

    this.show();
  },
  hide: function hide() {
    if (this.visible) {
      this.visible = false;
      this.focus.style.opacity = 0;
    }
  },
  show: function show() {
    this.visible = true;
    this.focus.style.opacity = 1;
  },
  setFocus: function setFocus(element) {
    var customFocus = new CustomEvent('customFocus', {
      bubbles: true,
      cancelable: true
    });
    element.dispatchEvent(customFocus);
  }
};

/***/ })
/******/ ]);
});